USE astrad;
DELIMITER |

--

DROP PROCEDURE IF EXISTS `SET_REALM`|
CREATE PROCEDURE `SET_REALM`(IN val varchar(80),IN event varchar(30))
BEGIN
  DECLARE account VARCHAR(30);
  DECLARE secret char(80);
  DECLARE md5_secret char(32);
  DECLARE no_more_rows BOOLEAN;
  DECLARE loop_cntr INT DEFAULT 0;
  DECLARE num_rows INT DEFAULT 0;
  DECLARE friends_cur CURSOR FOR SELECT acc.id, acc.h323_password FROM `porta-billing`.Accounts acc,`porta-billing`.Customers cus WHERE acc.i_customer=cus.i_customer AND cus.i_rep IN (3,17,5,9,12) AND acc.i_env=1 AND acc.id NOT regexp '^([0-9]{1,3}[.]){3}[0-9]{1,3}$';
  DECLARE CONTINUE HANDLER FOR NOT FOUND
    SET no_more_rows = TRUE;
  OPEN friends_cur;
  SELECT FOUND_ROWS() INTO num_rows;
  the_loop: LOOP
    FETCH friends_cur INTO account, secret;
    IF no_more_rows THEN
        CLOSE friends_cur;
        LEAVE the_loop;
    END IF;
IF secret IS NOT NULL THEN
      UPDATE users SET md5secret=md5(CONCAT(account,':',val,':',secret)) WHERE username=account;
ELSE
  UPDATE users SET md5secret=md5(CONCAT(account,':',val,':')) WHERE username=account;
END IF;
END LOOP the_loop;
INSERT INTO triggers_log (table_name,event,log_time,comment) VALUES ('realm',event,NOW(),CONCAT('update realm of all users :',num_rows));
END |
DELIMITER ;


--
-- Dumping triggers for table `Accounts`
--
USE `porta-billing`;
DELIMITER |

DROP TRIGGER IF EXISTS `Trg_Insert_Accounts`|
CREATE TRIGGER `Trg_Insert_Accounts` AFTER INSERT ON `Accounts` FOR EACH ROW BEGIN
  IF NEW.i_env=1 AND (SELECT 1 FROM Customers WHERE i_customer=NEW.i_customer AND i_rep IN (3,17,5,9,12)) THEN
    IF NEW.id REGEXP '^([0-9]{1,3}[.]){3}[0-9]{1,3}$' THEN
        INSERT INTO `astrad`.ip_customers (remote_ip,is_node) values (NEW.id,'N');
        INSERT INTO `astrad`.triggers_log (table_name,event,log_time,comment) VALUES ('Accounts','INSERT',NOW(),CONCAT('Add to ip_customers ',NEW.id));
    ELSE
      CALL INSERT_USER(NEW.id,NEW.h323_password,'INSERT','');
      INSERT INTO `astrad`.triggers_log (table_name,event,log_time,comment) VALUES ('Accounts','INSERT',NOW(),CONCAT('Add to users ',NEW.id));
    END IF;
  END IF;
END |

--
-- Dumping triggers for table `Customers`
--




DROP TRIGGER IF EXISTS `Trg_Update_Customers`|
CREATE TRIGGER `Trg_Update_Customers` AFTER UPDATE ON `Customers` FOR EACH ROW BEGIN
  IF OLD.i_rep IN (3,17,5,9,12) AND NEW.i_rep NOT IN (3,17,5,9,12) THEN
      CALL UPDATE_CUSTOMER(NEW.i_rep,NEW.i_customer);
  ELSEIF OLD.i_rep NOT IN (3,17,5,9,12) AND NEW.i_rep IN (3,17,5,9,12) THEN
      CALL UPDATE_CUSTOMER(NEW.i_rep,NEW.i_customer);
  END IF;
END |

DELIMITER ;

