USE `astrad`;

--
-- Dumping procedure add_multiple_ua
--

DELIMITER |
DROP PROCEDURE IF EXISTS `add_multiple_ua`|
CREATE PROCEDURE `add_multiple_ua`(IN USR VARCHAR(80), IN DOM VARCHAR(15),IN IP_ VARCHAR(15), IN PORT_ smallint(5) unsigned, IN USROLD VARCHAR(80), IN DOMOLD VARCHAR(15),IN IP_OLD VARCHAR(15), IN PORT_OLD smallint(5) unsigned, IN ACTION VARCHAR(80))
BEGIN
DECLARE REQ text DEFAULT '';
DECLARE tdomain varchar(15) default NULL;
DECLARE tipaddr varchar(15) default NULL;
DECLARE tport smallint(5) unsigned default NULL;
DECLARE done INT DEFAULT 0;
DECLARE cur CURSOR FOR select domain,ipaddr,port from location2 where username=USR;
DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;

IF ACTION = 'ADD' THEN
  IF (SELECT COUNT(username) FROM location2 WHERE username=USR AND expires > DATE_SUB(NOW(), INTERVAL 30 MINUTE)) > 1 THEN
    OPEN cur;
      read_loop: LOOP
      FETCH cur INTO tdomain,tipaddr,tport;
      IF done THEN
        LEAVE read_loop;
      END IF;
	  IF (SELECT COUNT(username) FROM asterisk.multiple_ua WHERE username=USR AND domain=tdomain AND ipaddr=tipaddr AND port=tport) = 0 THEN
        SET REQ=CONCAT(REQ,"('",USR,"','",tdomain,"','",tipaddr,"','",tport,"'),");
      END IF;
      END LOOP;
    CLOSE cur;
	IF REQ != '' THEN
      SET REQ=LEFT(REQ, char_length(REQ) - 1);
      SET REQ=CONCAT("INSERT IGNORE INTO multiple_ua VALUES ",REQ);
      INSERT INTO request (val) VALUES (REQ);
	END IF;
  END IF;
ELSEIF ACTION = 'DEL' THEN
  SET REQ=CONCAT("DELETE FROM multiple_ua WHERE username='",USR,"' AND domain='",DOM,"' AND ipaddr='",IP_,"' AND port=",PORT_);
  INSERT INTO request (val) VALUES (REQ);
ELSE
  IF USR != USROLD OR DOM != DOMOLD OR IP_ != IP_OLD OR PORT_ != PORT_OLD THEN
    SET REQ=CONCAT("UPDATE multiple_ua SET username='",USR,"', domain='",DOM,"', ipaddr='",IP_,"', port=",PORT_," WHERE username='",USROLD,"' AND domain='",DOMOLD,"' AND ipaddr='",IP_OLD,"' AND port=",PORT_OLD);
    INSERT INTO request (val) VALUES (REQ);
  END IF;
END IF;
END |
DELIMITER ;


--
-- Dumping triggers for table `location2`
--

DELIMITER |
DROP TRIGGER IF EXISTS `Trg_Insert_location2`|
CREATE TRIGGER `Trg_Insert_location2` AFTER INSERT ON `location2` FOR EACH ROW BEGIN
DECLARE IPAD varchar(15) DEFAULT '';
SET IPAD=(SELECT value FROM config WHERE name='ipaddr');
IF NEW.ipaddr IS NOT NULL AND NEW.port IS NOT NULL AND NEW.expires IS NOT NULL AND NEW.dba=IPAD THEN
  INSERT INTO registration (username,dba,domain,ipaddr,port,expires,register,useragent,action) VALUES (NEW.username,NEW.dba,NEW.domain,NEW.ipaddr,NEW.port,NEW.expires,NEW.register,NEW.useragent,'REGISTER');
END IF;
CALL add_multiple_ua(NEW.username,NEW.domain,NEW.ipaddr,NEW.port,NULL,NULL,NULL,NULL,"ADD");
END |

--

DROP TRIGGER IF EXISTS `Trg_Update_location2`|
CREATE TRIGGER `Trg_Update_location2` AFTER UPDATE ON `location2` FOR EACH ROW BEGIN
DECLARE IPAD varchar(15) DEFAULT '';
SET IPAD=(SELECT value FROM config WHERE name='ipaddr');
IF NEW.ipaddr IS NOT NULL AND NEW.port IS NOT NULL AND NEW.expires IS NOT NULL AND NEW.dba=IPAD THEN
  IF OLD.username != NEW.username OR OLD.dba != NEW.dba OR OLD.domain != NEW.domain OR OLD.ipaddr != NEW.ipaddr OR OLD.port != NEW.port THEN
    INSERT INTO registration (username,dba,domain,ipaddr,port,expires,register,useragent,action) VALUES (OLD.username,OLD.dba,OLD.domain,OLD.ipaddr,OLD.port,OLD.expires,OLD.register,OLD.useragent,'UNREGISTER');
  END IF;
  INSERT INTO registration (username,dba,domain,ipaddr,port,expires,register,useragent,action) VALUES (NEW.username,NEW.dba,NEW.domain,NEW.ipaddr,NEW.port,NEW.expires,NEW.register,NEW.useragent,'REGISTER');
END IF;
CALL add_multiple_ua(NEW.username,NEW.domain,NEW.ipaddr,NEW.port,OLD.username,OLD.domain,OLD.ipaddr,OLD.port,"UPD");
END |

--

DROP TRIGGER IF EXISTS `Trg_Delete_location2`|
CREATE TRIGGER `Trg_Delete_location2` AFTER DELETE ON `location2` FOR EACH ROW BEGIN
DECLARE IPAD varchar(15) DEFAULT '';
SET IPAD=(SELECT value FROM config WHERE name='ipaddr');
IF OLD.dba=IPAD THEN
  INSERT INTO registration (username,dba,domain,ipaddr,port,expires,register,useragent,action) VALUES (OLD.username,OLD.dba,OLD.domain,OLD.ipaddr,OLD.port,OLD.expires,OLD.register,OLD.useragent,'UNREGISTER');
END IF;
CALL add_multiple_ua(OLD.username,OLD.domain,OLD.ipaddr,OLD.port,NULL,NULL,NULL,NULL,"DEL");
END |
DELIMITER ;




